# Complexité des algorithmes - TP
# ===============================

# Exercice 2
# ----------

import random
import time
import matplotlib.pyplot as plt
import copy
import sys

# ========================================================================================
# Création de listes de taille incrémentale et de contenu aléatoire
NBLISTES = 15
NBVALMIN = 200
donneesRandom = []
donneesTriees = []
donneesInversees = []
axis = []
for i in range(1, NBLISTES + 1):
    jeudonneesRandom = []
    jeudonneesTriees = []
    jeudonneesInversees = []
    for j in range(NBVALMIN * i):
        jeudonneesRandom.append(j)
        jeudonneesTriees.append(j)
        jeudonneesInversees.append(j)
    jeudonneesInversees.reverse()
    random.shuffle(jeudonneesRandom)
    donneesRandom.append(jeudonneesRandom)
    donneesTriees.append(jeudonneesTriees)
    donneesInversees.append(jeudonneesInversees)
    axis.append(NBVALMIN * i)


def estTrie(l):
    for i in range(len(l) - 1):
        if l[i] > l[i + 1]: return False
    return True


def sontTries(l):
    for i in range(len(l)):
        if not estTrie(l[i]): return (False, i)
    return (True, 0)

sys.setrecursionlimit(10000)

def executerTri(fct_tri, color, nom, surplace=True):
    toplotRandom = []
    toplotTriees = []
    toplotInversees = []
    donneesTestRandom = copy.deepcopy(donneesRandom)
    donneesTestTriees = copy.deepcopy(donneesTriees)
    donneesTestInversees = copy.deepcopy(donneesInversees)
    for i in range(len(donneesRandom)):
        time1 = time.time()
        if surplace:
            fct_tri(donneesTestRandom[i])
        else:
            donneesTestRandom[i] = fct_tri(donneesTestRandom[i])
        time2 = time.time()
        toplotRandom.append(time2 - time1)

        time3 = time.time()
        if surplace:
            fct_tri(donneesTestTriees[i])
        else:
            donneesTestTriees[i] = fct_tri(donneesTestTriees[i])
        time4 = time.time()
        toplotTriees.append(time4 - time3)

        time5 = time.time()
        if surplace:
            fct_tri(donneesTestInversees[i])
        else:
            donneesTestInversees[i] = fct_tri(donneesTestInversees[i])
        time6 = time.time()
        toplotInversees.append(time6 - time5)

    (ok1, ipb1) = sontTries(donneesTestRandom)
    (ok2, ipb2) = sontTries(donneesTestTriees)
    (ok3, ipb3) = sontTries(donneesTestInversees)
    if not ok1:
        print(nom + ' donnees random incorrect, liste #' + str(ipb1))
    else:
        plt.plot(axis, toplotRandom, '-' + color, label=nom + ' (random)')

    if not ok2:
        print(nom + ' donnees triees incorrect, liste #' + str(ipb2))
    else:
        plt.plot(axis, toplotTriees, '--' + color, label=nom + ' (triees)')

    if not ok3:
        print(nom + ' donnees inversees incorrect, liste #' + str(ipb3))
    else:
        plt.plot(axis, toplotInversees, ':' + color, label=nom + ' (inversees)')


# ========================================================================================
# ========================================================================================
# Tri bulle
# def tri_bulle (tab):
# ##### TODO #####

#executerTri(tri_bulle,'r','Tri bulle')

# ========================================================================================
# Tri par insertion
# def tri_par_insertion (tab) :
# ##### TODO #####

#executerTri(tri_par_insertion,'b','Tri par insertion')

# ========================================================================================
# Tri par sélection
#def tri_par_selection (tab) :
# ##### TODO #####

#executerTri(tri_par_selection,'g','Tri par sélection')

# ========================================================================================
# Tri fusion
#def triFusion (tab):
# ##### TODO #####

#executerTri(triFusion,'k','Tri fusion',False)

# ========================================================================================
# Tri par base
#def TriRadix (tab) :
# ##### TODO #####

#executerTri(TriRadix,'y','Tri par base')

# ========================================================================================
# Tri rapide
#def triRapide (tab) :
# ##### TODO #####

#executerTri(triRapide,'c','Tri rapide')

# ========================================================================================
# Tri comptage
#def triComptage (L) :
# ##### TODO #####

#executerTri(triComptage,'m','Tri comptage',False)

# ========================================================================================
#plt.yscale('log')
plt.grid(True)
plt.legend(loc='upper left')
plt.show()